<?php
/*
 * 易游支付 https://pay.zy13.net
 * Date: 2024/7/25
 * Time: 22:38
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究接口使用，只是提供一个参考，最终解释权归美奇软件开发工作室所有。
 * 严禁一切钓鱼、色情、赌博、私彩及违反国家法律法规等使用。
 * 注意：
 * UTF-8编码不要在记事本下编辑，否则会出现一些奇葩的问题，正确方法应在开发工具里打开编辑
 */
ini_set("error_reporting","E_ALL & ~E_NOTICE");
header('Content-Type:application/json; charset=utf-8');
require "config.php";
require "Des.php";
///////////////////////////////////////////////
//下面代码基本不需要修改
if (empty($_POST)) $_POST = $_GET;  //如果为GET方式访问
if(version_compare(PHP_VERSION,'5.4.0','<')){
	outputError('PHP版本要求大于5.4.0');
}
if (version_compare(PHP_VERSION, '7.0.0') >= 0) {
	outputError('PHP版本不得大于7.0，推荐使用PHP5.6');
}
if(!isset($_POST['appid'])){
	outputError('参数非法');
}
//验证商户号
if($_POST['appid']!=$appid){
	outputError('商户编号不正确');
}
if (!function_exists('openssl_encrypt')){
	outputError('请开启php.ini的openssl扩展');
}
//解密接口参数
$des = new Des();
$parameter=$_POST['parameter'];
$decode=$des->decrypt($parameter,$deskey);
if(empty($decode)){
	outputError('算法密钥不正确');
}
parse_str($decode, $data);
//验证商户密钥
if($appkey!=$data['appkey']){
	outputError('商户密钥不正确');
}
//开始充值
chongzhi($data);

function chongzhi($data){
	//全局变量，函数内调用需要加global声明
	global $quarr;
	try{
		//游戏充值代码
		$account = $data['account'];
		$alias = $data['alias'];
		$scale = $data['scale'];
		$money = intval($data['money']);
		$gold=$money*$scale;//元宝=充值金额*充值比例
		if(isset($data['param']) && !empty($data['param'])){
			//游戏内充值
			$serverid = $data['param'];		
		}else{
			//模拟充值
			$serverid = 1;
		}
		//根据分区ID选择分区
		if($quarr[$serverid]){
			$zone = $quarr[$serverid];
		}else{
			$zone = $quarr[1];
		}
		if(empty($zone)){
		    outputError("查询游戏区服信息失败");
		}
		$conn = @mysql_connect($zone["db_ip"],$zone["db_user"],$zone["db_pswd"],$zone["db_port"]) or outputError("数据库连接失败!");
		//mysql_query("set names 'utf8'");
		mysql_select_db($zone['db_name'],$conn);
		$result = mysql_query("select roleid,yr_playername from p_role where yr_account='{$account}' and yr_createserverid='{$serverid}'");//SQL语句
    	if($result && mysql_num_rows($result)>0){
    	    $row = mysql_fetch_array($result);
    	    if (isset($row['roleid']) && !empty($row['roleid'])) {
    	        $roleid = $row['roleid'];
                $playername = $row['yr_playername'];
                $time = time();
                $params = array(
                    "ACCOUNT" => (string)$account, //账号
                    "GOLD" => (string)$gold, //钻石数
                    "OID" => (string)$time, //订单
                    "REASON" => "", //注释掉则不生成游戏订单
                    "SID" => (string)$serverid, //分区
                    "TYPE" => "1", 
                    "agent" => "yy", //渠道
                    "msgid" => "2", 
                    "time" => (string)$time, //时间戳
                );
                $params['sign'] = md5(http_build_query($params) . $zone['key']);
                $ip = $zone['gmip'];
                $port = $zone['gmport'];
                $socket = @socket_create(AF_INET,SOCK_STREAM,SOL_TCP) or outputError("socket创建失败");
                @socket_connect($socket,$ip,$port) or outputError("socket连接失败");
                @socket_write($socket, json_encode($params) . "!#!") or outputError("socket消息发送失败");
                socket_close($socket);
                $text = $gold>=10000?($gold/10000).'万':$gold;
            	$msg = sprintf("账号%s成功充值金额%s元，获得%s：%s个",$account,$money,$alias,$text);
            	outputSuccess($msg);
    	    }
    	}else{
    	    outputError("查询角色信息失败，账号：".$account);
    	}
	} catch (Exception $e) {
		outputError('充值异常，Error：'.$e->getMessage());
	}
}

function outputError($msg){
	$arr=array('code'=>0,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

function outputSuccess($msg){
	$arr=array('code'=>1,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

/** 
 * 打印日志
 * $msg 日志内容
 */
function printLog($msg) {
	if (!is_dir('log')){
		mkdir('log',0777,true);
	}
	$path="log/".date('Y-m-d').".log";
	file_put_contents($path, "【" . date('Y-m-d H:i:s') . "】" . $msg . "\r\n\r\n", FILE_APPEND);
}